
Ruby - Bug #21114

Prism hangs up while parsing deeply nested `def`

02/05/2025 11:24 AM - tompng (tomoya ishida)

Status: Closed   

Priority: Normal   

Assignee: prism   

Target version:    

ruby -v: ruby 3.5.0dev (2025-02-05T08:15:30Z

master 141f2924ee) +PRISM

[x86_64-linux]

Backport: 3.1: DONTNEED, 3.2: DONTNEED, 3.3:

WONTFIX, 3.4: DONE

Description

Prism.parse "def f\n" * 500 # Ruby 3.4

Prism.parse "def f\n" * 5000 # Ruby 3.5

Prism.parse "def initialize: ()->void\n" * 250 # Ruby 3.4

Prism.parse "def initialize: ()->void\n" * 2500 # Ruby 3.5

#=> hang up, Ctrl-C doesn't work

 Expect to raise ParseError with @type=:nesting_too_deep like Prism.parse '(1+'*10000

Background

Runnning rdoc in ruby/rbs directory with Ruby 3.4, RDoc hangs up.

RDoc tries to parse the partial file content, and stops with stdlib/ripper/0/ripper.rbs (

https://github.com/ruby/rbs/blob/a7178b12b041f5b304f4076aa01efed817ba8040/stdlib/ripper/0/ripper.rbs)

Parseable checking code in RDoc 

https://github.com/ruby/rdoc/blob/14a7631a3775e033791f13baa3be76c94b908e3d/lib/rdoc/markup/to_html.rb#L437

def parseable? text

  ...

  eval("BEGIN { throw :valid, true }\n#{text}")

  ...

end

 However, RBS doesn't seem to use RDoc, so I think it's not a big problem.

Associated revisions

Revision b21e1aed2ed5b22b50efc658289a403eeed581df - 02/13/2025 07:12 PM - kddnewton (Kevin Newton)

[ruby/prism] Fix infinite loop in error recovery

When recovering from a depth error that occurs at the end of the

file, we need to break out of parsing statements.

Fixes [Bug #21114]

https://github.com/ruby/prism/commit/a32e268787

Revision b21e1aed2ed5b22b50efc658289a403eeed581df - 02/13/2025 07:12 PM - kddnewton (Kevin Newton)

[ruby/prism] Fix infinite loop in error recovery

When recovering from a depth error that occurs at the end of the

file, we need to break out of parsing statements.

Fixes [Bug #21114]

https://github.com/ruby/prism/commit/a32e268787

Revision b21e1aed - 02/13/2025 07:12 PM - kddnewton (Kevin Newton)

[ruby/prism] Fix infinite loop in error recovery
When recovering from a depth error that occurs at the end of the

file, we need to break out of parsing statements.

Fixes [Bug #21114]

https://github.com/ruby/prism/commit/a32e268787

Revision 9a0984436888a59f4914c3035c53657baf62ce2b - 02/14/2025 05:17 AM - k0kubun (Takashi Kokubun)

merge revision(s) b21e1aed2ed5b22b50efc658289a403eeed581df: [Backport #21114]

    [ruby/prism] Fix infinite loop in error recovery

    When recovering from a depth error that occurs at the end of the

    file, we need to break out of parsing statements.

    Fixes [Bug #21114]

    https://github.com/ruby/prism/commit/a32e268787

Revision 9a0984436888a59f4914c3035c53657baf62ce2b - 02/14/2025 05:17 AM - k0kubun (Takashi Kokubun)

merge revision(s) b21e1aed2ed5b22b50efc658289a403eeed581df: [Backport #21114]

    [ruby/prism] Fix infinite loop in error recovery

    When recovering from a depth error that occurs at the end of the

    file, we need to break out of parsing statements.

    Fixes [Bug #21114]

    https://github.com/ruby/prism/commit/a32e268787

Revision 9a098443 - 02/14/2025 05:17 AM - k0kubun (Takashi Kokubun)

merge revision(s) b21e1aed2ed5b22b50efc658289a403eeed581df: [Backport #21114]

    [ruby/prism] Fix infinite loop in error recovery

    When recovering from a depth error that occurs at the end of the

    file, we need to break out of parsing statements.

    Fixes [Bug #21114]

    https://github.com/ruby/prism/commit/a32e268787

History

#1 - 02/12/2025 08:29 AM - hsbt (Hiroshi SHIBATA)

- Status changed from Open to Assigned

#2 - 02/13/2025 06:59 PM - kddnewton (Kevin Newton)

https://github.com/ruby/prism/pull/3461

#3 - 02/13/2025 07:12 PM - kddnewton (Kevin Newton)

- Status changed from Assigned to Closed

Applied in changeset git|b21e1aed2ed5b22b50efc658289a403eeed581df.

[ruby/prism] Fix infinite loop in error recovery

When recovering from a depth error that occurs at the end of the

file, we need to break out of parsing statements.

Fixes [Bug #21114]

https://github.com/ruby/prism/commit/a32e268787

#4 - 02/13/2025 08:05 PM - kddnewton (Kevin Newton)

- Backport changed from 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: UNKNOWN, 3.4: UNKNOWN to 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: UNKNOWN,
3.4: REQUIRED

#5 - 02/14/2025 05:17 AM - k0kubun (Takashi Kokubun)

- Backport changed from 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: UNKNOWN, 3.4: REQUIRED to 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: UNKNOWN,

3.4: DONE

ruby_3_4 9a0984436888a59f4914c3035c53657baf62ce2b merged revision(s) b21e1aed2ed5b22b50efc658289a403eeed581df.

#6 - 03/30/2025 03:21 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: UNKNOWN, 3.4: DONE to 3.1: DONTNEED, 3.2: DONTNEED, 3.3: WONTFIX, 3.4:

DONE
